//  j2s.h, the jed-to-sue header, comprises
//  variables and functions added to jed.
//  Structure changes are still in the original headers
//  since they could not be moved.

extern void goto_prev_position (void);
// cursor back to last posiiton

//extern void delete_line();
// from buffer.c

extern int kill_line(void);
// from cmds.c

extern SLKeyMap_List_Type *Ctrl_Map;
extern SLKeyMap_List_Type *Alt_Map;
// two maps added for <ctrl>, <alt> modifiers

extern int shiftkey_select (void);
// 1 if shiftkey selection active in current buffer

extern int get_modifier (void);
// provide shift status, unix.c

extern int modifier;
// also used for shift status, unix.c

extern int shiftkey_pressed;
extern int ctrlkey_pressed;
extern int shiftctrlkey_pressed;
extern int altkey_pressed;
// 0 not pressed, 1 pressed


extern int Cancel_MiniBuffer;
// exit and discard any result from minibuffer


extern int N_ROW, W_COL, S_ROW, E_COL;
// coordinates for last rectangle, globally available

extern int x_permit;
// allow jumps in rectangles otherwise illegal

extern int rectwidth;
// used in mark_rectangle, screen.c
// must be reset when rectangle starts

extern int BegRow, BegPoint, EndRow, EndPoint;
extern Line *BegL, *EndL;
//  start/end coordinates of character block

extern int toggle_block (int *blktype);
// start block of any type

extern int check_rectangle (void);
// determine rectangle borders

extern int check_stream (void);
// determine char block delimiters

extern int block_type (void);
// return blocktype for current buffer

//  rect operations
extern int shift_rectangle_right(void);
extern int shift_rectangle_left(void);
extern int open_rectangle(void);
extern int copy_rectangle(void);
extern int cut_rectangle(void);
extern int handle_rect_case (int *what);
// handles case in rectangles

extern void restore_selection (void);
extern void restore_rectangle (void);
// restore stream or rectangle

extern int Jed_Load_Readonly;

extern int lineblock_to_stream (void);
extern int stream_to_lineblock (void);

extern int shift_linetext_right(void);
extern int shift_linetext_left(void);
extern int kill_line2 (void);

extern SLKeyMap_List_Type *Slim_Map;

extern int DeletionToKillArray;

void repeat_last_kbd_command (void);

extern void prevbuffer (void);
extern void nextbuffer (void);

extern void save_selection (void);

extern void hide_status_indicators (int *what);

extern int jed_get_fg (char *obj);

extern char ttmp[10];

extern int debuG;

extern int rectangle_to_lineblock(void);

extern void revise_keys(void);

extern void split_unsplit ();

extern int SINGLE_ESCAPE;

extern char *best_keystring;
extern int mdf;
extern int kludge;
